.TH XWUD 1 "21 November 1986" "X Version 10"
.SH NAME
xwud - X Window System, window image undumper
.SH SYNOPSIS
.B "xwud"
[ -debug ] [ -help ] [ -inverse ] [ -in \fIfile\fP ]
[ \fIhost\fP:\fIdisplay\fP ]
.SH DESCRIPTION
.PP
.I Xwud
is an X Window System (protocol version 10) window image undumping utility.
.I Xwud
allows X users to display window images that were saved in a specially
formatted window dump file.  The window  image  will  appear  at  the
coordinates of the original window from which the dump was taken.
This is a crude version of a more advanced utility that will be released
in the future.  The window dump file format is currently under
development; no guarantee of upward compatibility is made: the format will
be completely different under V11. Monochrome
dump files are displayed on a color monitor in the default foreground and
background colors. 
.PP
.B NOTE:
Windows can only be undumped on a display have at least as many bit planes
as the original display.
.SH ARGUMENT SUMMARY
.PP
.TP 8
.B "-help"
Print out the `Usage:' command syntax summary.
.PP
.TP 8
.B "-in \fIfile\fP"
This argument allows the user to explicitly specify the input 
file on the command line.  The default is to take input from standard in.
.PP
.TP 8
.B -inverse
Applies to monochrome window dump files only. If selected, the window is
undumped in reverse video. This is mainly needed because the display
is `write white', whereas dump files intended eventually to be written
to a printer are generally `write black'.
.PP
.TP 8
.B "\fIhost\fP:\fIdisplay\fP"
This  argument  allow  you  to  specify the host and display number on
which to display the window dump.  For example `xwud orpheus:1'
would specify that the dump will appear on display `1' on the machine
`orpheus'.  By default,
.I xwud
uses the host and display number stored in the environment variable
DISPLAY, and therefore this argument is not normally specified.
.SH ENVIRONMENT
.PP
.TP 8
.B DISPLAY
To get default host and display number.
.SH FILES
.PP
.TP 8
.B XWDFile.h
X Window Dump File format definition file.
.SH BUGS
.PP
Cannot always undump a XY format color dump file with the correct
colors since the original pixel\-to\-color correspondence will be lost
if new color\-map pixels have to be allocated.
.SH SEE ALSO
xwd(1), xpr(1), xdpr(1), X(1)
.SH AUTHOR
.PP
Copyright 1985, 1986, Massachusetts Institute of Technology.
.PP
See \fIX(1)\fP for a full copyright notice.
.PP
Tony Della Fera, Digital Equipment Corp., MIT Project Athena
.PP
William F. Wyatt, Smithsonian Astrophysical Observatory


